//+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

// M 15 min
#define MagicNum 10002

extern double TakeProfit     = 400;
extern double Lots           = 0.1;
extern double TrailingStop   = 115;
extern double StopLoss       = 170;

extern double MATrendPeriod  = 39;
extern double StDevValue     = 10.2;
extern double SDperiod       = 12;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
 int ChkOrders()  
{
for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      if(OrderMagicNumber()==MagicNum) 
        return(1); 
        else  return(0);
     } 
}
int start()
  {
   
   double MacdCurrent, MacdPrevious, SignalCurrent;
   double SignalPrevious, Ma0, Ma1, Ma2;
   int cnt, ticket, total;
   
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables
   Ma0=iMA(NULL,0,MATrendPeriod,0,0,PRICE_CLOSE,0);
   Ma1=iMA(NULL,0,MATrendPeriod,0,0,PRICE_CLOSE,2);
   Ma2=iMA(NULL,0,MATrendPeriod,0,0,PRICE_CLOSE,4);
   
  
   total=OrdersTotal();
//---- go trading only for first tiks of new bar
 
   
   if(ChkOrders() ==0 ) 
     if(Volume[0]>1) return;
     else
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      double StDev0 = iStdDev(Symbol(),0,SDperiod,0,MODE_EMA,PRICE_CLOSE,0)*10000; 
      // BUY
     if(Ma0>Ma1 && Ma2>Ma1 && StDev0 > StDevValue)  
      { 
         ticket=OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(Ask,Digits),3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",MagicNum,0,Green);
         return(0); 
        }
      // SELL
        if(Ma0<Ma1 && Ma2<Ma1 && StDev0 > StDevValue)
        {
         
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+StopLoss*Point,Bid-TakeProfit*Point,"",MagicNum,0,Red);
         return(0); 
        }
      return(0);
     }
     
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...  

       for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol()  && OrderMagicNumber() == MagicNum)  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?

            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?

            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
     
      return(0);
  }
// the end.

